import java.util.*;
//import java.lang.Integer.*;
import java.lang.*;
import java.io.*;

/** 
* Classe que controla as tarefas e trata os resultados
*/


public class Controlador_Tarefas {

//----------------------------------------------------------------------

private static final String homedir = Principal.homedir;
private int i;
private int resto = 0;
private int k2 = 0;
private int w = 0;
private int waux = 0;
private int nag;
private int id;
private static int p;
private Vector[] resultados;		// cada agente possui um vetor de 
									// resultados
private Vector[] resultados2;		// cada agente possui um vetor de 

private Vector auxResultado;		// contem o vetor de resulatado de todos
									// os agentes	
private Vector[] aux2Resultado;		// contem o vetor de resulatado de todos

private Vector caracter;
private Vector itiner;
private Vector itin;
private Vector variavel;
private Arquivo arq = null;
private Tarefa tar = null;
private Itinerario it = null;
private Variavel var = null;
private String[] res = {"resultado1","tempoOperacao","tempoTotal",
						"tempoParcial","resultado5"};
private static ListaTarefas tarefas = new ListaTarefas();

//----------------------------------------------------------------------

/*
* Variaveis da classe
*/

private static int porta;
private static String home;

//----------------------------------------------------------------------

public void init(){

	porta = Principal.porta;
	home = Principal.home; 
	//homedir = Principal.homedir;
	
}

//----------------------------------------------------------------------

public Controlador_Tarefas(){

	init();

}

public void armazenar_Tarefa(Tarefa tar){

	try{tar.armazena();}
	catch(IOException e){}

}

//----------------------------------------------------------------------

public void Editar_Tarefa(String tarefa){
}

//----------------------------------------------------------------------

public void Remover_Tarefa(String tarefa){
}

//----------------------------------------------------------------------

public void executar_Tarefa(String tarefa){

	ControlaAgentes ca = null;
	resto = 0;
	w = 0;

	Tarefa tar = new Tarefa(tarefa);
	
	itiner = new Vector(1);
	it = new Itinerario(tar.itinerario);
	try{itiner = it.le();}
	catch(IOException e){
		System.out.println("Nao consegui ler o itinerario");}
	
	variavel = new Vector(1);
	var = new Variavel(tar.variavel);
	try{variavel = var.le();}
	catch(IOException e){
		System.out.println("Nao consegui ler as variaveis");}

//.......................................................................

// INICIALIZACAO
	
	nag = tar.no_agentes;
	int aux2 = tar.medidas;
	auxResultado = new Vector(1);
	resultados2 = new Vector[aux2];
	ElemenTar elemAux = tarefas.procurar(tarefa);
	if(elemAux == null) {
		
		// Incluindo tarefa
		incluirTarefa(tar,auxResultado);
		
		// Inicializa os arquivos com os resultados:
		i = 0;
		while(i<aux2) { 
			resultados2[i] = new Vector(1);
			arq = new Arquivo(res[i],homedir+"resultados","txt");
			try{
				arq.escreve(resultados2[0]);
			}
			catch(IOException e){System.out.println("Nao consegui escrever: " + e);}
			i++;
		}
		i = 2; 
		while(i<4) {
			if(tar.pegarMedTemp(res[i])) {
				arq = new Arquivo(res[i],homedir+"resultados","txt");
				try{
					arq.escreve(resultados2[0]);
				}
				catch(IOException e) {
					System.out.println("Nao consegui escrever: " + e);}
			}
			i++;
		}
	}
	else elemAux.zeraVetor(auxResultado);
	
	// Inicializa os vetores dos resultados:

	int j = 0;
	int p = AgMovel.pegarProxId();
	tarefas.procurar(tarefa).primeiroAgente(p);
	while(p+j<nag+p){
		resultados2 = new Vector[aux2];
		i = 0;
		while(i<aux2){ 
			resultados2[i] = new Vector(1);
			i++;
		}
		auxResultado.add(resultados2);
		j++;
	}
	

//.......................................................................

	// escolha do agente a ser executado
	
	int nr = 0;
	long tInicial;
	

		if(tar.entrega_de_resultado.equals("enviar")){
			int aux = tar.no_saltos;
				
			if(tar.Otempo.equals("Toperacao")){
				tInicial = System.currentTimeMillis();
				tarefas.procurar(tarefa).tempoInic(tInicial);
				while(nr<nag){
					itin = pegarItinerario(itiner, nr);
				
					Agente02_1 a21 = new Agente02_1(itin,variavel,home,porta,
													aux,tarefa, tar.operacao);
					Thread t = new Thread(a21);
					ca = new ControlaAgentes(a21,t);
					ca.incluirAgente();
					ca.comeca();
					nr++;
				}
			}
			else{	
				tInicial = System.currentTimeMillis();
				tarefas.procurar(tarefa).tempoInic(tInicial);
				while(nr<nag){
					itin = pegarItinerario(itiner, nr);
					Agente02 a2 = new Agente02(itin,variavel,home,porta,
													aux,tarefa,tar.operacao);
					id = a2.id;
					Thread t = new Thread(a2);
					ca = new ControlaAgentes(a2,t);
					ca.incluirAgente();
					ca.comeca();
					nr++;
				}
			}
		}
		else{
			tInicial = System.currentTimeMillis();
			tarefas.procurar(tarefa).tempoInic(tInicial);
			while(nr<nag){
				itin = pegarItinerario(itiner, nr);
				Agente01 a1 = new Agente01(itin,variavel,home,porta,tarefa,
																tar.operacao); 
				id = a1.id;
				Thread t = new Thread(a1);
				ca = new ControlaAgentes(a1,t);
				ca.incluirAgente();
				ca.comeca();
				nr++;
			}
		}
	
	
}

//----------------------------------------------------------------------

public void Cancelar_Tarefa(String tarefa){

}

//----------------------------------------------------------------------

public void entregarResultado(Mensagem m){
	
	id = m.quemMandou();
	resultados = m.lerResultado();
	int i = id-tarefas.procurar(m.pegarTarefa()).pegarPrimoAg();
	int t = java.lang.reflect.Array.getLength(resultados);
	int k = 0;
	auxResultado = tarefas.procurar(m.pegarTarefa()).pegarVetor();
	while(k<t){  
		((Vector[] )(auxResultado.get(i)))[k].addAll(resultados[k]);
		k++;
	}
	
}

//----------------------------------------------------------------------

public void incluirTarefa(Tarefa nome, Vector v){

	tarefas.incluir(nome,v);

}

//----------------------------------------------------------------------

public void excluirTarefa(String t){

	tarefas.excluir(t);

}

//----------------------------------------------------------------------

private Vector pegarItinerario(Vector itn, int nr) {

	int posicao = 0;
	if(k2 == 0) {	
		k2 = itn.size()/nag;
		if(k2*nag<itn.size()) {
			resto = itn.size() - (k2*nag);
			w = 1;
		}
	
	}
	if(resto == 0) w = 0;
	else resto--;
	Vector aux_itiner = null;
	int k = 0;
	aux_itiner = new Vector(1);
	while((k<(k2+w)) && ((k+nr*k2)<itiner.size())){
		posicao = k + nr*k2 +waux;
		aux_itiner.add(itn.get(posicao));
		k++;
	}
	if(!(w == 0)) waux++;
	return(aux_itiner);
}

//----------------------------------------------------------------------

public void termino(int idAgente, String tar){

	long t1, t2, tf;
	int m;
	long[] taux;
	Vector resAux = new Vector(1);
	ElemenTar elem = tarefas.procurar(tar);
	
	elem.agTerminou();		
	if(elem.acabouTarefa()){
		m = elem.pegarMedidas();
		if(m >1) {
			t2 = System.currentTimeMillis();
			t1 = elem.pegarTempoInic();
			tf = t2-t1;
			resAux.add(new Long(tf));
			if(elem.pegarMedTemp(res[2])) 
				guardaResultado(resAux, res[2]);
		}
		guardaResultado(elem.pegarVetor());
		if(elem.maisUmaVez()) {
			int inter = elem.novamente();
			if(inter>0) {
				try{Thread.sleep(inter*1000);}
				catch(Exception ei) {
					System.out.println("Insonia...");
				}
			}	
			executar_Tarefa(tar);
		}
		else {
			excluirTarefa(tar);
			Arquivo arq2 = new Arquivo(res[0], homedir+"resultados","txt");
			try{arq2.consertarArq();}
			catch(IOException e) {
				System.out.println("Nao consegui apagar as linhas: " + e);
			}
			System.out.println(elem.pegarNoVez()+"------ Agora ACABOU.");
		}
	}
	
	
			
}

//----------------------------------------------------------------------

private void guardaResultado(Vector resulta) {

	Vector[] raux = null; 
	int h = 0;	
	while(h<resulta.size()) {
		raux = (Vector[] )resulta.get(h);
		int t = java.lang.reflect.Array.getLength(raux);
		int k = 0;
		while(k<t){
			arq = new Arquivo(res[k],homedir+"resultados","txt");
			try{
				arq.acrescenta(raux[k]);
			}
			catch(IOException e) {
				System.out.println("Nao consegui escrever: " + e);
			}
			k++;
		}
		h++;
	}

}

//----------------------------------------------------------------------

private void guardaResultado(Vector resulta, String narq) {

			arq = new Arquivo(narq,homedir+"resultados","txt");
			try{
				arq.acrescenta(resulta);
			}
			catch(IOException e) {
				System.out.println("Nao consegui escrever: " + e);
			}
}

//----------------------------------------------------------------------

}
