// Mensagem.java

import java.net.*;
import java.util.*;
import java.io.*;

//-------------------------------------------------------------------------

public class Mensagem implements Serializable {

//-------------------------------------------------------------------------

private Socket sock = null;
private String endOrigem;
private String destinatario;
private String endDestino;
private String tarefa;
private String mensagem;
private Vector[] resultado = null;
private int rtam = 0;
private int porta = 0;
private int idAgente = 0;
private long idMensagem = (new Random()).nextLong();

//-------------------------------------------------------------------------

public Mensagem(String msg, String ede, int por, String tar) {

	init(msg,ede,por,tar);
}

//-------------------------------------------------------------------------

public Mensagem(String msg, String ede, int por, int des, String tar) {

	init(msg,ede,por,tar);
	idAgente = des;
}

//-------------------------------------------------------------------------

public Mensagem(String msg, String ede, int por, String des, int id, Vector[] res, String tar) {

	init(msg,ede,por,tar);
	destinatario = des;
	idAgente = id;
	rtam = java.lang.reflect.Array.getLength(res);
	resultado = new Vector[rtam];
	int n =0;
	while(n <rtam){
		resultado[n] = res[n];
		n++;
	}
}

//-------------------------------------------------------------------------

private void init(String msg, String ede, int por, String tar) {

//	endOrigem = eor;
	mensagem = msg;
	tarefa = tar;
	endDestino = ede;
	porta = por;
}

//-------------------------------------------------------------------------

public void udp_Enviar(){
}

//-------------------------------------------------------------------------

public void enviar(){

	Servidor_Mensagens.enviar(endDestino, porta, this);

}

//-------------------------------------------------------------------------

public String ler(){

	return(mensagem);

}

//-------------------------------------------------------------------------

public Vector[] lerResultado(){

	return(resultado);

}

//-------------------------------------------------------------------------

public int quemMandou(){

	return(idAgente);

}

//-------------------------------------------------------------------------

public String pegarTarefa(){

	return(tarefa);

}

//-------------------------------------------------------------------------

}
