/***************************************************************************
 * AgMovel.java
 *
 ***************************************************************************/

import java.util.*;
import java.lang.reflect.*;
import java.io.Serializable;
import java.rmi.*;

//-------------------------------------------------------------------------

public class AgMovel extends Agente
	implements Serializable {

//-------------------------------------------------------------------------

	protected int it_tam = 0;
	protected int var_tam = 0;
	protected int porta = 0;
	protected Vector itinerario = null;
	protected Vector variaveis = null;
	protected String home  = null;
	protected String tarefa = null;
	public int id =0;
	private static int idAg =0;

//-------------------------------------------------------------------------

protected AgMovel(Vector it, Vector var, String h,int po, String tar) {

	itinerario = it;
	tarefa = tar;
	variaveis = var;
	it_tam = it.size();
	var_tam = var.size();
	home = h;
	porta = po;
	id = idAg++;       //(new Random()).nextInt(1000);
}

//-------------------------------------------------------------------------

public void run() {
}

//-------------------------------------------------------------------------

protected final void migrar(String destino, int porta)
				throws MigrarException {
    Servidor_Agente.enviar(destino, porta, this);
}

//-------------------------------------------------------------------------

protected final void acabei() {

	Mensagem m = new Mensagem("acabei",this.home, this.porta, this.id, tarefa); 
	m.enviar();
}

//-------------------------------------------------------------------------

public int pegarId() {

	return(this.id);

}

//-------------------------------------------------------------------------

public static int pegarProxId() {

	return(idAg);

}

//-------------------------------------------------------------------------

public String pegarTarefa() {

	return(tarefa);

}

//-------------------------------------------------------------------------
}
