
//package agente;

import java.io.*;
import java.net.*;
import java.lang.*;

class Servidor_Agente extends Servidor implements Runnable {
	
		
public Servidor_Agente(String maq, int porta){

	super(porta+1);
}

public void run() {
	
	while(true){
		Socket s1 = this.espera_Pedido();
		ServAg filho = new ServAg(s1);
		filho.start();
	}
		
		//this.fecha_Conexao();
}


public static Socket iniciar(String endDestino, int porta) 
			throws MigrarException {


    InetAddress server_IP = null;
	try {
		server_IP = InetAddress.getByName(endDestino);
	}
	catch (java.net.UnknownHostException e) {
		System.err.println("Deu merda...   Host nao conhecido");
		throw new MigrarException(e.toString());
		//System.exit(1);
	}
	Socket sock = null;

    try {
	    sock = new Socket(server_IP, porta);
    }
    catch (IOException e) {
	    System.err.println("Socket nao funcionou...");
		throw new MigrarException(e.toString());
   	 	//System.exit(1);
    }
	return(sock);
}

public static void enviar(String end, int porta, AgMovel ag)
				throws MigrarException {
	Socket sock = iniciar(end, porta+1);
	try{
	//	System.out.println("Enviando agente...");
		ObjectOutputStream saida = new 
					ObjectOutputStream(sock.getOutputStream());
		saida.writeObject(ag);
		saida.flush();
	}
	catch (IOException e) {
		System.err.println("Deu merda..."+ e);
		throw new MigrarException(e.toString());
	//	System.exit(1);
	}
	finally {
		try {
   			sock.close();
   			}
   		catch (IOException e) {
   			System.err.println("Nao consegui fechar o socket...");
   			System.exit(1);
   		}
		try{
			Thread.currentThread().stop();
		}
		catch(SecurityException e){
   			System.err.println("Nao consegui interromper o agente");
		}
			
   	}

}


}


